Subject: [netlmm] FW: some comments on Sri's draft

From: "Sri Gundavelli" <[email-masked]>
Date: Sun, 18 Mar 2007 01:47:49 -0700

Hi Sangjin,

Thanks for the review. Please see inline.

Regards
Sri

> -----Original Message-----
> From: Sangjin Jeong [mailto:[email-masked]] 
> Sent: Saturday, March 17, 2007 10:59 PM
> To: Sri Gundavelli
> Cc: [email-masked]
> Subject: some comments on Sri's draft
> 
> Hi Sri,
> 
> I think the draft is well-written, however, there exist some issues
> related to IPv4 support that are not clear and need to be considered.
> 

Thanks. That was the general input from many people, off course at least
one person, Alex has a different opinion :).

> The draft describes data tunneling in order to transport IPv6 or IPv4
> packet over IPv4-UDP encapsulation in the IPv4 network supporting
> NAT. However, the way about MN's IPv4 home link emulation under
> NAT does not seem to be clearly explained, IMHO.
> 
> Let me consider IPv4-only network between LMA and MAG.
> According to the draft, MAG can support IPv4 NAT.
> 
> 1) When IPv4-only MN boots up in the access network supporting
> NAT, the MN will be assigned IPv4 private address. Then, MAG
> will perform Proxy BU including MN's IPv4 HoA (private address)
> according to DS-MIPv6.
> 
> LMA will create binding cache and routing entry containing IPv4
> private address. Thus, the following routing table entry will be
> created for the MN's IPv4 HoA.
> =========
> IPv4-MN HoA(priv addr)/32 via tunnel ID, next hop IPv4 Proxy CoA
> =========
> 
> Therefore, I am wondering how IPv4 CN can send packets destined
> to MN's HoA.
> 

The NAT support in DSMIP6 or even in MIPv4 NAT Traversal is for
supporting the scenario where the IPv4-CoA address or one end-point of
the tunnel is a private IPv4 translated address. The scenario you are
referring to is about a private home address i.e Private IPv4-MN-HoA.
Just to emphasize, the address the mobile node is assigned in the access
network is from the mobile node's IPv4 Home Network Prefix and not from
a prefix on the access link. 

If a mobile node uses this address and communicates with any other CN
outside its private network, the address needs to be translated and
there needs to be a NAT setup in the path.

[CN]---{Internet}---[NAT]---[LMA]---[NAT]---[MAG]---[MN]

When the mobile node using a private address I1 (MN-HoA) initiates
a session with node in the internet, the packet will be tunneled
to the LMA and after decap, it will get forwarded. The NAT device
on the edge of the private network will translate this address to I1'
and this should be a globally routable public address, and will forward
it to the CN. Now, the traffic from CN to I1', will get translated back
to I1 at the NAT device and will hit the LMA. The LMA will forward the
traffic to the MAG in the tunnel. In this scenario, the presence of
NAT between LMA and MAG, the transport network, or the encapsulation
type, has no bearing on the mobile node's usage of the Private IPv4-HoA.
As long as the LMA has the correct IPv4-MN-HoA, what ever IPv4 address
that is configured on the mobile node, exists in the BCE, it should work
just fine. 

> 2) Let me assume that there are two MAGs, namely MAG#1 and
> MAG#2. MAG#1 has public IPv4 address prefix and MAG#2 has
> private IPv4 address prefix (i.e., MAG#2 supports NAT).
> 
> When IPv4-only MN boots up in MAG#2's access network, the MN
> will be assigned IPv4 MN-HoA in private address prefix. Later, if
> the MN moves into MAG#1's access network, then MAG#1 will
> detects the MN's attachment and perform Proxy BU with MN's IPv4
> MN-HoA (private IPv4 address)
> 
> In that case, does the Proxy BU sent to LMA include MN's IPv4
> MN HoA? Also, does the MN keep its previously assigned private IP
> address in the access network supporting public IPv4 address?
> 
> If so, binding cache and routing entry in LMA will include private
> IPv4 address. MN's roaming from MAG#1 to MAG#2 causes similar
> issues.
> 

As explained above, the IPv4 private home address and the type of
transport network are two different things. As long as the mobile
node gets an IPv4 address, private or public from its home network
prefix and when attached to any of the access networks in that
LMM domain, the mobility for that address is assured. Now, if some
MAG's are using a private address or a public address i.e. if the
transport network is over a NAT device, it should still be fine.
To your specific question on if the IPv4-MN-HoA will be present in
the PBU, as explained in DSMIP6, its optional, if the option is
not present and if there was BCE in the LMA, the LMA will allocate
an IPv4 address. If the option was not present in the PBU and if
the LMA has a BCE for the mobile node with the IPv4-MN-HoA, the
same will be returned in the PBA. Typically, the mobile node does
DHCP to obtain the IPv4 address configuration. As explained in
the document and as in any normal DHCP configurations, the Relay
Agent will set the giaddr field to the mobile node's IPv4 HNP, so
that it gets an IPv4 address from that prefix block. Again, this
this is a normal operation and this document is defining all this
operation. This is all leveraged from DSMIP6.

Thanks
Sri

_______________________________________________
netlmm mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/netlmm

---

From: "Sangjin Jeong" <[email-masked]>
Date: Sun, 18 Mar 2007 22:36:51 +0100

Sri,

Thanks for clarification.

Regards,
Sangjin

> a prefix on the access link.

I understand what you are considering.
However, when both CN(private address) and MN are in private network,
how the CN

---

From: "Sangjin Jeong" <[email-masked]>
Date: Tue, 20 Mar 2007 01:00:48 +0100

Hi Sri,

Thanks for kind explanation.
Please see inline.

Regards,
Sangjin

> a prefix on the access link.

Let me assume that an access router supports MAG function and NAT.
In that case, the access router would have DHCP server function so as to
assign private IP address to hosts in the access network (private net).

Also, the access router would require DHCP relay function in order to
relay DHCP message from mobile node to DHCP sever that will assign
IPv4 Home Network Prefix to the mobile node.

Therefore, when a mobile node powers up in a private access network
and initiates DHCP procedure by sending DHCPDISCOVER message,
I am wondering how the access router will decide whether to relay the
DHCP message to DHCP server that has IPv4 Home Network Prefix or
to assign a private IP address to the mobile node by DHCP server in
the access router.
I am not sure if DHCP specification supports such function.